import List

type Matrix a = [[a]]

-- All operations are to be done on Rows,Columns and Boxes

-- transpose, built-in, converts rows to columns and back.
-- We  define boxTransp, a  function to convert boxes to rows and back!

chop i [] = []
chop i l = (take i l):chop i (drop i l)

-- constructing the boxes. Boxing exactly 3 rows is easy
boxTransp3r :: Matrix a -> Matrix a
boxTransp3r m = map concat (transpose (map (chop 3) m))

-- Boxing K rows. Box 3 rows at a time and concatenate
boxTransp :: Matrix a -> Matrix a
boxTransp = concatMap boxTransp3r. (chop 3) 
	
full = [[11,12,13,14,15,16,17,18,19],
	[21,22,23,24,25,26,27,28,29],
	[31,32,33,34,35,36,37,38,39],
	[41,42,43,44,45,46,47,48,49],
	[51,52,53,54,55,56,57,58,59],
	[61,62,63,64,65,66,67,68,69],
	[71,72,73,74,75,76,77,78,79],
	[81,82,83,84,85,86,87,88,89],
	[91,92,93,94,95,96,97,98,99]]
