type Vert = Int

maxvert = 6

edge :: Vert -> Vert -> Bool 
edge 1 2 = True
edge 1 4 = True
edge 2 3 = True
edge 3 6 = True
edge 3 1 = True
edge 4 6 = True
edge 5 4 = True
edge 5 6 = True
edge _ _ =False

extend :: Vert -> [Vert]
extend v = [w | w <- [1..maxvert], edge v w]

extendall :: [Vert] -> [Vert]
extendall = concatMap extend

reachable v = concat (take maxvert (iterate extendall [v]))
